Loading...
Searching...
No Matches
ASSA::Socketbuf Class Reference

`#include <Socketbuf.h>`

Inheritance diagram for ASSA::Socketbuf:

## Public Member Functions

| Socketbuf (Socket *s_)
virtual | ~Socketbuf ()
Public Member Functions inherited from ASSA::Streambuf
virtual | ~Streambuf ()
Streambuf * | pubsetbuf (char *s_, int n_)
| Set buffer.
int | pubsync ()
int | in_avail ()
| This function returns the number of characters immediately available in the get area.
int | snextc ()
| This function moves the get pointer forward one position, then returns the character after the get pointer's new position.
int | sbumpc ()
| This function should probably have been called `‘sgetc’'.
int | sgetc ()
| This function returns the character after the get pointer, or EOF if the get pointer is at the end of the sequence.
int | sgetn (char *b_, int len_)
| This function gets the next len_ characters following the get pointer, copying them to the char array pointed to by b_; it advances the get pointer past the last character fetched.
int | sputc (char c_)
| This function stores c just after the put pointer, and advances the pointer one position, possibly extending the sequence.
int | sputn (char *b_, int len_)
| From the location pointed to by ptr, stores exactly len characters after the put pointer, advancing the put pointer just past the last character.
void | unbuffered (int i_)
| If i_ is non-zero, then all IO operations are buffered.
int | unbuffered ()
Public Member Functions inherited from ASSA::io_ptrs
| io_ptrs ()
void | dump () const

## Protected Member Functions

virtual int | sync ()
| This function synchronizes the streambuf with its actual stream of characters.
virtual int | underflow ()
| This function is called to supply characters for input (from some source) when the get area is empty, although it may be called at other times.
virtual int | overflow (int c_=EOF)
| This function is called to consume characters (flush them to output), typically when the put area is full and an attempt is made to store another character.
virtual int | showmanyc ()
| The morphemes of showmanyc are "es-how-many-see", not "show-man-ic".
virtual int | doallocate ()
| This function is called by allocate when unbuffered() is zero and base() is zero.
Protected Member Functions inherited from ASSA::Streambuf
| Streambuf ()
| The default constructor is protected for class Streambuf to asssure that only objects for classes derived from this class may be constructed.
| Streambuf (const Streambuf &)
Streambuf & | operator= (const Streambuf &)
char * | base () const
| Returns the lowest possible value for gptr() - the beginning of the get area.
char * | gptr () const
| Returns a pointer to the beginning of the get area, and thus to the next character to be fetched (if there are any).
char * | egptr () const
| Returns a pointer just past the end of the get area, the maximum possible value for gptr().
void | setg (char *gbeg_, char *gnext_, char *gend_)
| Set get area pointers.
char * | pbase () const
| Returns a pointer to the beginning fo the space available for the put area, the lowest possible value for pptr().
char * | pptr () const
| Returns a pointer to the beginning of the put area, and thus to the location of the next character that is stored (if possible).
char * | epptr () const
| Returns a pointer just past the end of the put area, the maximum possible value for pptr().
void | setp (char *pbeg_, char *pend_)
| Set put area pointers.
void | pbump (int n_)
| Advances the next pointer for the output sequence by n_.
void | setb (char *b_, char *eb_, int del_)
| Establish the reserve area (buffer).
void | init ()
virtual Streambuf * | setbuf (char *p_, int len_)
| Performs an operation that is defined separately for each class derived from Streambuf.
virtual int | xsgetn (char *b_, int len_)
| Assigns up to len_ characters to successive elements of the array whose first element is designated by b_.
virtual int | uflow ()
| Reads the characters from the input sequence, if possible, and moves the stream position past it, as follows:
virtual int | xsputn (const char *b_, int len_)
| Writes up to len_ characters to the output sequence as if by repeated calls to sputc (c).

## Private Member Functions

int | flush_output ()
int | sys_read (char *b_, int len_)
int | sys_write (char *b_, int len_)
void | xput_char (char c_)

## Private Attributes

Socket * | m_s
| Reference to the Socket stream.

## Additional Inherited Members

Public Types inherited from ASSA::io_ptrs
enum | { USER_BUF = 1 , UNBUFFERED = 2 , EOF_SEEN = 4 , ERR_SEEN = 8 }
Public Attributes inherited from ASSA::io_ptrs
char * | m_read_base
char * | m_read_ptr
char * | m_read_end
char * | m_write_base
char * | m_write_ptr
char * | m_write_end
char * | m_buf_base
char * | m_buf_end
int | m_flags
char | m_shortbuf [1]
Static Public Attributes inherited from ASSA::Streambuf
static const int | MAXTCPFRAMESZ = 65536
| Size of the internal input/output buffer.

## Detailed Description

Definition at line 29 of file Socketbuf.h.

## Constructor & Destructor Documentation

## Socketbuf()

Socketbuf::Socketbuf | ( | Socket * | s_ | ) |

Definition at line 24 of file Socketbuf.cpp.

: m_s (s_)
{
trace_with_mask("Socketbuf::Socketbuf",STRMBUFTRACE);
// By default, I am doing buffering IO
unbuffered (0);
}
trace_with_mask
#define trace_with_mask(s, m)
trace_with_mask() is used to trace function call chain in C++ program.
Definition Logger.h:437
ASSA::AutoPtrRef
A wrapper class to provide AutoPtr with reference semantics.
Definition AutoPtr.h:32
ASSA::Socketbuf::m_s
Socket * m_s
Reference to the Socket stream.
Definition Socketbuf.h:51
ASSA::Streambuf::unbuffered
int unbuffered()
Definition Streambuf.h:408
ASSA::STRMBUFTRACE
@ STRMBUFTRACE
Extended Streambuf & friends messages
Definition LogMask.h:46

References ASSA::STRMBUFTRACE, trace_with_mask, and ASSA::Streambuf::unbuffered().

## ~Socketbuf()

Socketbuf::~Socketbuf | ( |  | ) |

virtual

Definition at line 58 of file Socketbuf.cpp.

{
trace_with_mask("Socketbuf::~Socketbuf",STRMBUFTRACE);
overflow (EOF); // flush put area
}
ASSA::Socketbuf::overflow
virtual int overflow(int c_=EOF)
This function is called to consume characters (flush them to output), typically when the put area is ...
Definition Socketbuf.cpp:162

References overflow(), ASSA::STRMBUFTRACE, and trace_with_mask.

## Member Function Documentation

## doallocate()

int Socketbuf::doallocate | ( |  | ) |

protected virtual

This function is called by allocate when unbuffered() is zero and base() is zero.

It attempts to make a buffer of suitable size available. On success it must call setb to establish the reserve area, then return a value greater than zero. On failure it returns EOF. The default behavior is to allocate a buffer using new.

Reimplemented from ASSA::Streambuf.

Definition at line 226 of file Socketbuf.cpp.

{
trace_with_mask("Socketbuf::doallocate",STRMBUFTRACE);
// Get area comes first and matches entier buffer area.
// Put area comes right after it. They are two equally-sized
// separate buffers.
//
// ------------ -
// | | ^
// | get area | | buffer area
// | | v
// ------------ -
// | put area |
// | |
// ------------
//
// Return 1 on allocation and 0 if there is no need
if (m_buf_base)
return 0;
if ( ! (m_flags & UNBUFFERED) ) {
DL((STRMBUF,"Buffered IO - allocating %d bytes\n",
2 * MAXTCPFRAMESZ));
char* buf = new char [2 * MAXTCPFRAMESZ];
setg (buf, buf + MAXTCPFRAMESZ, buf + MAXTCPFRAMESZ);
setb (buf, buf + MAXTCPFRAMESZ, 1);
buf += MAXTCPFRAMESZ;
setp (buf, buf+MAXTCPFRAMESZ);
}
else {
DL((STRMBUF,"Unbuffered IO - same 1 byte array\n"));
setb (m_shortbuf, m_shortbuf+1, 0);
// read_base is pointing to the begining, and
// read_end to one past end of the buffer.
// Because buffer is empty, read_ptr should point
// to the end (same as read_end). This way, calling
// routines will detect that get area needs data from sync.
//
// +- read_base +- read_ptr
// | |- read_end
// | |+----- one past end-of-block
// v vv
// +--------------+-+
// | get area | |
// +--------------+-+
setg (m_shortbuf, m_shortbuf+1, m_shortbuf+1);
// write_base & write_ptr are pointing to the begining,
// and write_end to one past end of the buffer.
// Because buffer is empty, read_ptr should point
// to the beginning (same as write_base). This way, calling
// routines will detect that put area needs data from sync.
//
// +- write_base +- write_end points one past
// |- write_ptr | end-of-block
// v v
// +--------------+-+
// | put area | |
// +--------------+-+
setp (m_shortbuf, m_shortbuf+1);
}
dump ();
return 1;
}
DL
#define DL(X)
A macro for writing debug message to the Logger.
Definition Logger.h:273
ASSA::Streambuf::setp
void setp(char *pbeg_, char *pend_)
Set put area pointers.
Definition Streambuf.h:588
ASSA::Streambuf::MAXTCPFRAMESZ
static const int MAXTCPFRAMESZ
Size of the internal input/output buffer.
Definition Streambuf.h:106
ASSA::Streambuf::setb
void setb(char *b_, char *eb_, int del_)
Establish the reserve area (buffer).
Definition Streambuf.cpp:80
ASSA::Streambuf::setg
void setg(char *gbeg_, char *gnext_, char *gend_)
Set get area pointers.
Definition Streambuf.cpp:69
ASSA::io_ptrs::m_shortbuf
char m_shortbuf[1]
Definition Streambuf.h:47
ASSA::io_ptrs::m_buf_base
char * m_buf_base
Definition Streambuf.h:41
ASSA::io_ptrs::UNBUFFERED
@ UNBUFFERED
Definition Streambuf.h:44
ASSA::io_ptrs::dump
void dump() const
Definition Streambuf.cpp:23
ASSA::io_ptrs::m_flags
int m_flags
Definition Streambuf.h:46
ASSA::STRMBUF
@ STRMBUF
Class Streambuf & friends messages
Definition LogMask.h:45

References DL, ASSA::io_ptrs::dump(), ASSA::io_ptrs::m_buf_base, ASSA::io_ptrs::m_flags, ASSA::io_ptrs::m_shortbuf, ASSA::Streambuf::MAXTCPFRAMESZ, ASSA::Streambuf::setb(), ASSA::Streambuf::setg(), ASSA::Streambuf::setp(), ASSA::STRMBUF, ASSA::STRMBUFTRACE, trace_with_mask, and ASSA::io_ptrs::UNBUFFERED.

Referenced by overflow(), and underflow().

## flush_output()

int Socketbuf::flush_output | ( |  | ) |

private

Definition at line 191 of file Socketbuf.cpp.

{
trace_with_mask("Socketbuf::flush_output",STRMBUFTRACE);
if (pptr () <= pbase ()) { // Nothing to flush
return 0;
}
int requested;
int xmitted;
requested = pptr () - pbase ();
if ((xmitted = sys_write (pbase (), requested)) < 0) {
return EOF;
}
if (unbuffered ()) {
setp (pbase (), epptr ());
return 0;
}
requested -= xmitted;
setp (pbase (), pbase () + MAXTCPFRAMESZ);
pbump (requested);
if (requested > 0) {
::memmove (pbase (), pbase () + xmitted, requested);
}
return 0;
}
ASSA::Socketbuf::sys_write
int sys_write(char *b_, int len_)
Definition Socketbuf.cpp:86
ASSA::Streambuf::pptr
char * pptr() const
Returns a pointer to the beginning of the put area, and thus to the location of the next character th...
Definition Streambuf.h:499
ASSA::Streambuf::epptr
char * epptr() const
Returns a pointer just past the end of the put area, the maximum possible value for pptr().
Definition Streambuf.h:507
ASSA::Streambuf::pbase
char * pbase() const
Returns a pointer to the beginning fo the space available for the put area, the lowest possible value...
Definition Streambuf.h:491
ASSA::Streambuf::pbump
void pbump(int n_)
Advances the next pointer for the output sequence by n_.
Definition Streambuf.h:515

References ASSA::Streambuf::epptr(), ASSA::Streambuf::MAXTCPFRAMESZ, ASSA::Streambuf::pbase(), ASSA::Streambuf::pbump(), ASSA::Streambuf::pptr(), ASSA::Streambuf::setp(), ASSA::STRMBUFTRACE, sys_write(), trace_with_mask, and ASSA::Streambuf::unbuffered().

Referenced by overflow(), and sync().

## overflow()

int Socketbuf::overflow | ( | int | c = `EOF` | ) |

protected virtual

This function is called to consume characters (flush them to output), typically when the put area is full and an attempt is made to store another character.

If c is not EOF, overflow must either store or consume the character, following those already in the put area. It returns EOF on error, any other value on success. The default behavior of the base class version is undefined, so each derived class must define its own overflow. The normal action for a derived class version is to consume the characters in the put area (those between pbase() and pptr()), call setp() to set up a new put area, then store c (using sputc()) if it is not EOF.

Reimplemented from ASSA::Streambuf.

Definition at line 161 of file Socketbuf.cpp.

{
trace_with_mask("Socketbuf::overflow",STRMBUFTRACE);
// If c == EOF, return flush_output()
// Otherwise, insert c into the buffer
if (c_ == EOF)
return flush_output ();
if (pbase () == 0 && doallocate () == EOF)
return EOF;
if (pptr () >= epptr() && flush_output () == EOF)
return EOF;
xput_char (c_);
dump ();
if ((unbuffered () || pptr () >= epptr ()) && flush_output () == EOF)
return EOF;
dump ();
return c_;
}
ASSA::Socketbuf::flush_output
int flush_output()
Definition Socketbuf.cpp:192
ASSA::Socketbuf::doallocate
virtual int doallocate()
This function is called by allocate when unbuffered() is zero and base() is zero.
Definition Socketbuf.cpp:226
ASSA::Socketbuf::xput_char
void xput_char(char c_)
Definition Socketbuf.cpp:51

References doallocate(), ASSA::io_ptrs::dump(), ASSA::Streambuf::epptr(), flush_output(), ASSA::Streambuf::pbase(), ASSA::Streambuf::pptr(), ASSA::STRMBUFTRACE, trace_with_mask, ASSA::Streambuf::unbuffered(), and xput_char().

Referenced by ~Socketbuf().

## showmanyc()

int Socketbuf::showmanyc | ( |  | ) |

protected virtual

The morphemes of showmanyc are "es-how-many-see",
not "show-man-ic".

Return an estimate of the number of characters available in the sequence, or -1. If it returns a positive value,
then successive calls to underflow() will not return EOF until at least that number of characters have been supplied.
If showmanyc() returns -1, then calls to underflow() or uflow() will fail. The intention is not only that these calls will not return EOF, but that they will return `‘immediately.’'

Reimplemented from ASSA::Streambuf.

Definition at line 42 of file Socketbuf.cpp.

{
trace_with_mask("Socketbuf::showmanyc",STRMBUFTRACE);
return m_s->getBytesAvail ();
}
ASSA::Socket::getBytesAvail
int getBytesAvail(void) const
Return number of bytes available in socket receive buffer.
Definition Socket.cpp:48

References ASSA::Socket::getBytesAvail(), m_s, ASSA::STRMBUFTRACE, and trace_with_mask.

## sync()

int Socketbuf::sync | ( |  | ) |

protected virtual

This function synchronizes the streambuf with its actual stream of characters.

The derived class version should flush any characters in the put area to their final destination, and if possible give back any characters in the input buffer to their source. It should return EOF on any error, zero on success. The default behavior of the base class version is to return zero if there are no pending input or output characters (in_avail() and out_waiting() are both zero), and return EOF otherwise.

Reimplemented from ASSA::Streambuf.

Definition at line 34 of file Socketbuf.cpp.

{
trace_with_mask("Socketbuf::sync",STRMBUFTRACE);
return flush_output ();
}

References flush_output(), ASSA::STRMBUFTRACE, and trace_with_mask.

## sys_read()

int Socketbuf::sys_read | ( | char * | b_,
|  | int | len_
| ) |  |

private

Definition at line 66 of file Socketbuf.cpp.

{
trace_with_mask("Socketbuf::sys_read",STRMBUFTRACE);
int ret = ::recv (m_s->getHandler (), b_, len_, 0);
DL((STRMBUFTRACE,"Tried to read %d bytes from fd=%d\n",
len_, m_s->getHandler ()));
DL((STRMBUFTRACE,"::recv() returned %d\n", ret));
if (ret == -1) {
DL((STRMBUFTRACE,"::recv() error: %d (%s)\n",
errno, strerror (get_errno ())));
}
return (ret);
}
ASSA::Socket::getHandler
virtual handler_t getHandler() const =0
Get file descriptor.
ASSA::get_errno
int get_errno()
Fetch error number in a portable way.
Definition Logger_Impl.h:115

References DL, ASSA::get_errno(), ASSA::Socket::getHandler(), m_s, ASSA::STRMBUFTRACE, and trace_with_mask.

Referenced by underflow().

## sys_write()

int Socketbuf::sys_write | ( | char * | b_,
|  | int | len_
| ) |  |

private

Definition at line 85 of file Socketbuf.cpp.

{
trace_with_mask("Socketbuf::sys_write",STRMBUFTRACE);
int ret = ::send (m_s->getHandler (), b_, len_, 0);
DL((STRMBUFTRACE,"Tried to write %d bytes to fd=%d\n",
len_, m_s->getHandler ()));
DL((STRMBUFTRACE,"::send() returned %d\n", ret));
if (ret == -1) {
DL((STRMBUFTRACE,"::send() error: %d\n",errno));
}
return (ret);
}

References DL, ASSA::Socket::getHandler(), m_s, ASSA::STRMBUFTRACE, and trace_with_mask.

Referenced by flush_output().

## underflow()

int Socketbuf::underflow | ( |  | ) |

protected virtual

This function is called to supply characters for input (from some source) when the get area is empty, although it may be called at other times.

If the get area is not empty, it should just return the first character (without advancing the get pointer). If the get area is empty, it should establish a new get area, aquire new input, and return the first character, if any. If no input characters are available, it should leave an empty get area and return EOF. The default behavior of the base class version is undefined, so each derived class must define its own underflow.

Reimplemented from ASSA::Streambuf.

Definition at line 104 of file Socketbuf.cpp.

{
/*
The important thing to note is that this function
returns:
a) pointer to the first character in buffer available.
b) EOF if sys_read () failed.
In case of peer closing its connection, a) will be true.
Caller can always find out number of bytes in buffer
and determine if peer indeed closed connection.
*/
trace_with_mask("Socketbuf::underflow",STRMBUFTRACE);
if (gptr () < egptr ()) // The get area is not empty,
{
return *(unsigned char*) gptr (); // return 1st character
}
if (base () == 0 && // If buffer isn't established,
doallocate () == EOF) // allocate buffer (both buff & unbuff IO)
{
return EOF;
}
int bufsz = unbuffered () ? 1 : MAXTCPFRAMESZ;
/*
Read as much as I can up to the allocated buffer size.
EOF = (-1).
*/
int rval = sys_read (base (), bufsz);
DL((STRMBUF,"Socketbuf::sys_read() returned %d bytes\n", rval));
if (rval == EOF)
{
if (get_errno () != EWOULDBLOCK) {
m_flags |= EOF_SEEN;
}
return EOF;
}
DL((STRMBUF,"Having read %d bytes from socket\n",rval));
MemDump::dump_to_log (STRMBUF, "Data received:", base (), rval);
// Set get area pointers according to the data just read
setg (base (), base (), base () + rval);
dump ();
return (*(unsigned char*) gptr ()); // Return front character
}
ASSA::MemDump::dump_to_log
static void dump_to_log(unsigned long mask_, const char *info_, const char *msg_, int len_)
Write hex/ascii dump of a memory region to log file.
Definition MemDump.cpp:111
ASSA::Socketbuf::sys_read
int sys_read(char *b_, int len_)
Definition Socketbuf.cpp:67
ASSA::Streambuf::base
char * base() const
Returns the lowest possible value for gptr() - the beginning of the get area.
Definition Streambuf.h:464
ASSA::Streambuf::egptr
char * egptr() const
Returns a pointer just past the end of the get area, the maximum possible value for gptr().
Definition Streambuf.h:482
ASSA::Streambuf::gptr
char * gptr() const
Returns a pointer to the beginning of the get area, and thus to the next character to be fetched (if ...
Definition Streambuf.h:473
ASSA::io_ptrs::EOF_SEEN
@ EOF_SEEN
Definition Streambuf.h:44

References ASSA::Streambuf::base(), DL, doallocate(), ASSA::io_ptrs::dump(), ASSA::MemDump::dump_to_log(), ASSA::Streambuf::egptr(), ASSA::io_ptrs::EOF_SEEN, ASSA::get_errno(), ASSA::Streambuf::gptr(), ASSA::io_ptrs::m_flags, ASSA::Streambuf::MAXTCPFRAMESZ, ASSA::Streambuf::setg(), ASSA::STRMBUF, ASSA::STRMBUFTRACE, sys_read(), trace_with_mask, and ASSA::Streambuf::unbuffered().

## xput_char()

void Socketbuf::xput_char | ( | char | c_ | ) |

private

Definition at line 50 of file Socketbuf.cpp.

{
trace_with_mask("Socketbuf::xput_char",STRMBUFTRACE);
*pptr() = c_;
pbump (1);
}

References ASSA::Streambuf::pbump(), ASSA::Streambuf::pptr(), ASSA::STRMBUFTRACE, and trace_with_mask.

Referenced by overflow().

## Member Data Documentation

## m_s

Socket* ASSA::Socketbuf::m_s

private

Reference to the Socket stream.

Definition at line 51 of file Socketbuf.h.

Referenced by showmanyc(), sys_read(), and sys_write().

The documentation for this class was generated from the following files:

- Socketbuf.h
- Socketbuf.cpp